﻿Public Class Form1
    Private Const period As Integer = 24
    Private Colors() As Color

    ' Initialize the colors.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Redraw when resized.
        Me.ResizeRedraw = True

        Colors = New Color() _
        { _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet, _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet, _
            Color.Pink, _
            Color.Red, _
            Color.Orange, _
            Color.Yellow, _
            Color.Lime, _
            Color.Cyan, _
            Color.Blue, _
            Color.Violet _
        }
    End Sub

    ' Turn double buffering on or off.
    Private Sub chkDoubleBuffer_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDoubleBuffer.CheckedChanged
        Me.DoubleBuffered = chkDoubleBuffer.Checked

        ' Redraw.
        Me.Invalidate()
    End Sub

    ' Redraw.
    Private Sub btnRedraw_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRedraw.Click
        Me.Invalidate()
    End Sub

    ' Draw the butterfly.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.SmoothingMode = _
            System.Drawing.Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.Clear(Me.BackColor)

        ' Scale and translate.
        Dim world_rect As New RectangleF(-4.0F, -4.4F, 8.0F, 7.3F)
        Dim cx As Single = (world_rect.Left + world_rect.Right) / 2
        Dim cy As Single = (world_rect.Top + world_rect.Bottom) / 2

        ' Center the world coordinates at origin.
        e.Graphics.TranslateTransform(-cx, -cy)

        ' Scale to fill the form.
        Dim scale As Single = Math.Min( _
            Me.ClientSize.Width / world_rect.Width, _
            Me.ClientSize.Height / world_rect.Height)
        e.Graphics.ScaleTransform(scale, scale, _
            System.Drawing.Drawing2D.MatrixOrder.Append)

        ' Move the result to center on the form.
        e.Graphics.TranslateTransform( _
            Me.ClientSize.Width / 2, _
            Me.ClientSize.Height / 2, _
            System.Drawing.Drawing2D.MatrixOrder.Append)

        ' Generate the points.
        Dim pt0, pt1 As PointF
        Dim t As Double = 0
        Dim expr As Double = _
            Math.Exp(Math.Cos(t)) _
            - 2 * Math.Cos(4 * t) _
            - Math.Pow(Math.Sin(t / 12), 5)
        pt1 = New PointF( _
            CSng(Math.Sin(t) * expr), _
            CSng(-Math.Cos(t) * expr))
        Using the_pen As New Pen(Color.Blue, 0)
            Const num_lines As Long = 5000
            For i As Long = 0 To num_lines - 1
                t = i * period * Math.PI / num_lines
                expr = _
                    Math.Exp(Math.Cos(t)) _
                    - 2 * Math.Cos(4 * t) _
                    - Math.Pow(Math.Sin(t / 12), 5)
                pt0 = pt1
                pt1 = New PointF( _
                    CSng(Math.Sin(t) * expr), _
                    CSng(-Math.Cos(t) * expr))
                the_pen.Color = GetColor(t)
                e.Graphics.DrawLine(the_pen, pt0, pt1)
            Next i
        end Using
    End Sub

    ' Return an appropriate color for this segment.
    Private Function GetColor(ByVal t As Double) As Color
        Return Colors(Int(t / Math.PI))
    End Function
End Class
